// BDialog.cpp : implementation file
//

#include "stdafx.h"
#include "BDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CBDialog::CBDialog(UINT nIDTemplate, CWnd* pParent /*=NULL*/)
	: CDialog(nIDTemplate, pParent)
{
	m_style = StyleTile;
}
BOOL CBDialog::OnEraseBkgnd(CDC* pDC) 
{
	if(!m_bitmap.m_hObject)
		return true;
	
	CRect rect;
	GetClientRect(&rect);
	CDC dc;
	dc.CreateCompatibleDC(pDC);
	CBitmap* pOldBitmap = dc.SelectObject( &m_bitmap );
	int bmw, bmh ;
	BITMAP bmap;
	m_bitmap.GetBitmap(&bmap);
	bmw = bmap.bmWidth;
	bmh = bmap.bmHeight;
	int xo=0, yo=0;

	if(m_style == StyleTile)
	{
		for (yo = 0; yo < rect.Height(); yo += bmh)
		{
			for (xo = 0; xo < rect.Width(); xo += bmw)
			{
				pDC->BitBlt( xo, yo, rect.Width(), rect.Height(), &dc, 0, 0, SRCCOPY );
			}
		}
	}

	if(m_style == StyleCenter)
	{
		if( bmw < rect.Width() )
			xo = (rect.Width() - bmw) / 2;
		else 
			xo=0;
		if( bmh < rect.Height() )
			yo = (rect.Height()-bmh ) / 2;
		else
			yo=0;
		pDC->BitBlt( xo, yo, rect.Width(), rect.Height(), &dc, 0, 0, SRCCOPY );
	}

	if( m_style == StyleStretch )
	{
		pDC->StretchBlt( xo, yo, rect.Width(), rect.Height(), &dc, 0, 0, bmw, bmh, SRCCOPY );
	}

	
	dc.SelectObject( pOldBitmap );
	return true;
}

void CBDialog::SetBitmapStyle(int style)
{
	m_style = style;
}

int CBDialog::SetBitmap(UINT nIDResource)
{
	if(m_bitmap.LoadBitmap(nIDResource))
		return 0;
	else
		return 1;//error
}

void CBDialog::ReleaseBitmap()
{
	m_bitmap.DeleteObject();
}