#include "StdAfx.h"
#include "MobileConfigManager.h"

CMobileConfigManager::CMobileConfigManager(void)
{
	m_nUsingSessinAmount = -1;
	memset( m_MMS, 0, sizeof(MOBILE_MEDIA_SETTING) * _MAX_MOBILE_MEDIA_SETTING_AMOUNT );
	Init();
}

CMobileConfigManager::~CMobileConfigManager(void)
{
	CM_CloseInterface( m_hConfig );
}

bool CMobileConfigManager::SetValue( MOBILE_MEDIA_SETTING * pMMS )
{
	MOBILE_MEDIA_SETTING tmpMMS;
	memcpy( &tmpMMS, pMMS, sizeof(MOBILE_MEDIA_SETTING) );

	char szSessionName[64];
	sprintf( szSessionName, "%d\0", tmpMMS.nIndexNO );

	bool bret = true;
	// Camera name
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_NAME, tmpMMS.szCameraName, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Camera IP
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_IP, tmpMMS.szCameraIP, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	char szPort[16];
	// Register Port
	sprintf( szPort, "%d\0", tmpMMS.nRegisterPort );
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_R_PORT, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Control Port
	sprintf( szPort, "%d\0", tmpMMS.nControlPort );
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_C_PORT, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Streaming Port
	sprintf( szPort, "%d\0", tmpMMS.nStreamingPort );
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_V_PORT, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// HTTP Port
	sprintf( szPort, "%d\0", tmpMMS.nHTTPPort );
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_H_PORT, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Camera User Name
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_USER_NAME, tmpMMS.szUserName, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Camera Password
	bret = CM_SetValue( m_hConfig, _KEY_CAMERA_PASSWORD, tmpMMS.szPassword, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Using Streaming Engine
	if( tmpMMS.bUsingStreamingEngine )
		bret = CM_SetValue( m_hConfig, _KEY_SE_USE, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_SE_USE, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Streaming Engine IP
	bret = CM_SetValue( m_hConfig, _KEY_SE_IP, tmpMMS.szStreamingEngineIP, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Streaming Engine User Name
	bret = CM_SetValue( m_hConfig, _KEY_SE_USER_NAME, tmpMMS.szStreamingEngineUserName, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Streaming Engine Password
	bret = CM_SetValue( m_hConfig, _KEY_SE_PASSWORD, tmpMMS.szStreamingEnginePassword, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	sprintf( szPort, "%d\0", tmpMMS.nStreamingEngineControlPort );
	bret = CM_SetValue( m_hConfig, _KEY_SE_C_PORT, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	sprintf( szPort, "%d\0", tmpMMS.nStreamingEngineStreamingPort );
	bret = CM_SetValue( m_hConfig, _KEY_SE_V_PORT, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Enable PTZ
	if( tmpMMS.bEnablePTZ )
		bret = CM_SetValue( m_hConfig, _KEY_PTZ_ENABLE, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_PTZ_ENABLE, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// PTZ Source Type
	char szSourceType[16];
	sprintf( szSourceType, "%d\0", tmpMMS.nPTZProtocolSourceType );
	bret = CM_SetValue( m_hConfig, _KEY_PTZ_PROTOCOL_SOURCE_TYPE, szSourceType, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// PTZ Vender
	bret = CM_SetValue( m_hConfig, _KEY_PTZ_VENDER, tmpMMS.szPTZVender, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// PTZ Protocol
	bret = CM_SetValue( m_hConfig, _KEY_PTZ_PROTOCOL, tmpMMS.szPTZProtocol, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// PTZ Protocol File Name
	bret = CM_SetValue( m_hConfig, _KEY_PTZ_PROTOCOL_FILE_NAME, tmpMMS.szPTZProtocolFileName, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Join patrol group
	if( tmpMMS.bGroupIntoPatrol )
		bret = CM_SetValue( m_hConfig, _KEY_PATROL_GROUP_JOIN, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_PATROL_GROUP_JOIN, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Play Audio
	if( tmpMMS.bPlayAudio )
		bret = CM_SetValue( m_hConfig, _KEY_PLAY_AUDIO, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_PLAY_AUDIO, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Quad
	if( tmpMMS.bQuad )
		bret = CM_SetValue( m_hConfig, _KEY_QUAD, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_QUAD, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Show Camera Name
	if( tmpMMS.bShowCameraName )
		bret = CM_SetValue( m_hConfig, _KEY_SHOW_CAMERANAME, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_SHOW_CAMERANAME, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Show Event
	if( tmpMMS.bShowEvent )
		bret = CM_SetValue( m_hConfig, _KEY_SHOW_EVENT, "1\0", szSessionName, ME_PROFILE_FILE_NAME );
	else
		bret = CM_SetValue( m_hConfig, _KEY_SHOW_EVENT, "0\0", szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Serial Control
	sprintf( szPort, "%d\0", tmpMMS.nSerialControl );
	bret = CM_SetValue( m_hConfig, _KEY_SERIAL_CONTROL, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Serial Baud rate
	sprintf( szPort, "%d\0", tmpMMS.nSerialBaudRate );
	bret = CM_SetValue( m_hConfig, _KEY_SERIAL_BAUDRATE, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// PTZ AddressID
	if( tmpMMS.nPTZAddressID == 0 )
		tmpMMS.nPTZAddressID = 1;
	sprintf( szPort, "%d\0", tmpMMS.nPTZAddressID );
	bret = CM_SetValue( m_hConfig, _KEY_PTZ_ADDRESS_ID, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Streaming Type 
	if( tmpMMS.nTCPType == 0 )
		tmpMMS.nTCPType = 2;
	sprintf( szPort, "%d\0", tmpMMS.nTCPType );
	bret = CM_SetValue( m_hConfig, _KEY_STREAMING_TYPE, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// PTZ Speed
	if( tmpMMS.nPTZSpeed == 0 )
		tmpMMS.nPTZSpeed = 3;
	sprintf( szPort, "%d\0", tmpMMS.nPTZSpeed );
	bret = CM_SetValue( m_hConfig, _KEY_PTZ_SPEED, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	// Variable FPS
	sprintf( szPort, "%d\0", tmpMMS.nVariableFPS );
	bret = CM_SetValue( m_hConfig, _KEY_VARIABLE_FPS, szPort, szSessionName, ME_PROFILE_FILE_NAME );
	if( !bret ) return false;

	memcpy( &m_MMS[tmpMMS.nIndexNO], &tmpMMS, sizeof(MOBILE_MEDIA_SETTING) );
	return CM_Save( m_hConfig );
}

MOBILE_MEDIA_SETTING * CMobileConfigManager::GetValue( int nIndex )
{
	return &m_MMS[nIndex];
}

void CMobileConfigManager::Init()
{
	char szSessionName[64];
	char *pData = NULL;

	m_hConfig = CM_OpenInterface();

	m_nUsingSessinAmount = 15;
	for( int i = 0; i < 16; i++ )
	{
		m_MMS[i].nIndexNO = i;
		sprintf( szSessionName, "%d\0", i );
		// Camera name
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_NAME, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			//	m_nUsingSessinAmount = i;
			if( strlen(pData) > 0 )
				sprintf( m_MMS[i].szCameraName, "%s\0", pData );
			else
				sprintf( m_MMS[i].szCameraName, "Camera - %d\0", i+1 );
		}
		else
			sprintf( m_MMS[i].szCameraName, "Camera - %d\0", i+1 );

		// Camera IP
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_IP, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0 )
				sprintf( m_MMS[i].szCameraIP, "%s\0", pData );
			else
				sprintf( m_MMS[i].szCameraIP, "192.168.0.100\0" );
		}
		else
			sprintf( m_MMS[i].szCameraIP, "192.168.0.100\0" );

		// Register Port
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_R_PORT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0)
				m_MMS[i].nRegisterPort = atol( pData );
			else
				m_MMS[i].nRegisterPort = 6000;
		}
		else
			m_MMS[i].nRegisterPort = 6000;

		// Control Port
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_C_PORT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0)
				m_MMS[i].nControlPort = atol( pData );
			else
				m_MMS[i].nControlPort = 6001;
		}
		else
			m_MMS[i].nControlPort = 6001;

		// Streaming Port
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_V_PORT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0 )
				m_MMS[i].nStreamingPort = atol( pData );
			else
				m_MMS[i].nStreamingPort = 6002;
		}
		else
			m_MMS[i].nStreamingPort = 6002;

		// HTTP Port
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_H_PORT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0 )
				m_MMS[i].nHTTPPort = atol( pData );
			else
				m_MMS[i].nHTTPPort = 80;
		}
		else
			m_MMS[i].nHTTPPort = 80;

		// Camera User Name
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_USER_NAME, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData))
				sprintf( m_MMS[i].szUserName, "%s\0", pData );
			else
				sprintf( m_MMS[i].szUserName, "Admin\0" );
		}
		else
			sprintf( m_MMS[i].szUserName, "Admin\0" );

		// Camera Password
		pData = CM_GetValue( m_hConfig, _KEY_CAMERA_PASSWORD, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) )
				sprintf( m_MMS[i].szPassword, "%s\0", pData );
			else
				sprintf( m_MMS[i].szPassword, "123456\0" );
		}
		else
			sprintf( m_MMS[i].szPassword, "123456\0" );

		// Using Streaming Engine
		m_MMS[i].bUsingStreamingEngine = false;
		pData = CM_GetValue( m_hConfig, _KEY_SE_USE, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bUsingStreamingEngine = true;
		}

		// Streaming Engine IP
		pData = CM_GetValue( m_hConfig, _KEY_SE_IP, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			sprintf( m_MMS[i].szStreamingEngineIP, "%s\0", pData );

		// Streaming Engine User Name
		pData = CM_GetValue( m_hConfig, _KEY_SE_USER_NAME, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			sprintf( m_MMS[i].szStreamingEngineUserName, "%s\0", pData );

		// Streaming Engine Password
		pData = CM_GetValue( m_hConfig, _KEY_SE_PASSWORD, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			sprintf( m_MMS[i].szStreamingEnginePassword, "%s\0", pData );

		// Streaming Engine Control Port
		pData = CM_GetValue( m_hConfig, _KEY_SE_C_PORT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0)
				m_MMS[i].nStreamingEngineControlPort = atol( pData );
			else
				m_MMS[i].nStreamingEngineControlPort = 6001;
		}
		else
			m_MMS[i].nStreamingEngineControlPort = 6001;

		// Streaming Engine Streaming Port
		pData = CM_GetValue( m_hConfig, _KEY_SE_V_PORT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			if( strlen(pData) > 0)
				m_MMS[i].nStreamingEngineStreamingPort = atol( pData );
			else
				m_MMS[i].nStreamingEngineStreamingPort = 6002;
		}
		else
			m_MMS[i].nStreamingEngineStreamingPort = 6002;

		// Enable PTZ
		m_MMS[i].bEnablePTZ = false;
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_ENABLE, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bEnablePTZ = true;
		}

		// PTZ Source Type
		m_MMS[i].nPTZProtocolSourceType = 0;
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_ENABLE, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nPTZProtocolSourceType = atol( pData );

		// PTZ Vender
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_VENDER, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			sprintf( m_MMS[i].szPTZVender, "%s\0", pData );

		// PTZ Protocol
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_PROTOCOL, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			sprintf( m_MMS[i].szPTZProtocol, "%s\0", pData );

		// PTZ Protocol File Name
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_PROTOCOL_FILE_NAME, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			sprintf( m_MMS[i].szPTZProtocolFileName, "%s\0", pData );

		// Join Patrol Group
		m_MMS[i].bGroupIntoPatrol = false;
		pData = CM_GetValue( m_hConfig, _KEY_PATROL_GROUP_JOIN, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bGroupIntoPatrol = true;
		}

		// Play Audio
		m_MMS[i].bPlayAudio = false;
		pData = CM_GetValue( m_hConfig, _KEY_PLAY_AUDIO, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bPlayAudio = true;
		}

		// Quad
		m_MMS[i].bQuad = false;
		pData = CM_GetValue( m_hConfig, _KEY_QUAD, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bQuad = true;
		}

		// Show Camera Name
		m_MMS[i].bShowCameraName = false;
		pData = CM_GetValue( m_hConfig, _KEY_SHOW_CAMERANAME, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bShowCameraName = true;
		}

		// Show Event
		m_MMS[i].bShowEvent = false;
		pData = CM_GetValue( m_hConfig, _KEY_SHOW_EVENT, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
		{
			int n = atol( pData );
			if( n == 1 )
				m_MMS[i].bShowEvent = true;
		}

		// Serial Control
		pData = CM_GetValue( m_hConfig, _KEY_SERIAL_CONTROL, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nSerialControl = atol( pData );
		else
			m_MMS[i].nSerialControl = 0;

		// Serial Baud rate
		pData = CM_GetValue( m_hConfig, _KEY_SERIAL_BAUDRATE, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nSerialBaudRate = atol( pData );
		else
			m_MMS[i].nSerialBaudRate = 0;

		// Serial Baud rate
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_ADDRESS_ID, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nPTZAddressID = atol( pData );
		else
			m_MMS[i].nPTZAddressID = 1;
		if( m_MMS[i].nPTZAddressID == 0 )
			m_MMS[i].nPTZAddressID = 1;

		// Streaming Type
		pData = CM_GetValue( m_hConfig, _KEY_STREAMING_TYPE, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nTCPType = atol( pData );
		else
			m_MMS[i].nTCPType = 2;
		if( m_MMS[i].nTCPType == 0 )
			m_MMS[i].nTCPType = 2;

		// PTZ Speed
		pData = CM_GetValue( m_hConfig, _KEY_PTZ_SPEED, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nPTZSpeed = atol( pData );
		else
			m_MMS[i].nPTZSpeed = 3;
		if( m_MMS[i].nPTZSpeed == 0 )
			m_MMS[i].nPTZSpeed = 3;


		// Variable FPS
		pData = CM_GetValue( m_hConfig, _KEY_VARIABLE_FPS, szSessionName, ME_PROFILE_FILE_NAME );
		if( pData )
			m_MMS[i].nVariableFPS = atol( pData );
		else
			m_MMS[i].nVariableFPS = 0;

		if( m_MMS[i].nVariableFPS > 30 )
			m_MMS[i].nVariableFPS = 30;
	}
}
