/*********************************************************************

Project:      MobileExplorer 2.0

Description:  SDK 10000-Mobile Version and application sample

Modified:     Ken Chan

Author:       Ken Chan

Prototyping:

Created:      [Ken Chan]

Modified:

Email:		  Ken.Chan@ACTi.com; ken650613@yahoo.com.tw
MSN:          kennet2@giga.net.tw

*********************************************************************/

#include "stdafx.h"
#include "MobileExplorer.h"
#include "MobileExplorerDlg.h"
#include "WideVideoDlg.h"
#include "RS232SettingDlg.h"
#include "PTZAddressIDDlg.h"
#include "SEConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMobileExplorerDlg dialog

CMobileExplorerDlg::CMobileExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMobileExplorerDlg::IDD, pParent)
	, m_szCameraIP(_T("172.16.1.1"))
	, m_dwChannelNO(0)
	, m_nRPort(6000)
	, m_nCPort(6001)
	, m_nVPort(6002)
	, m_nHPort(80)
	, m_szUserName(_T("Admin"))
	, m_szPassword(_T("123456"))
	, m_szCameraName(_T("Camera Name"))
{
	m_bUseConnectToNVR = false;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bPTZChecked = false;
	m_bQuadChecked = false;
	m_bShowEventChecked = false;
	m_bDCNChecked = false;
	m_bGIPChecked = false;
	m_bPlayAudioChecked = false;
	m_bSettingChanged = false;
	m_szProtocolFileName = L"";
	m_nSerialControl = 0;
	m_nSerialRate = 0;
	m_nPTZAddressID = 1;
}

void CMobileExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT2, m_szCameraIP);
	//	DDV_MaxChars(pDX, m_szCameraIP, 15);
	DDX_Text(pDX, IDC_EDIT9, m_dwChannelNO);
	//	DDV_MinMaxUInt(pDX, m_dwChannelNO, 0, 16);
	DDX_Text(pDX, IDC_EDIT3, m_nRPort);
	//	DDV_MinMaxInt(pDX, m_nRPort, 1, 65535);
	DDX_Text(pDX, IDC_EDIT4, m_nCPort);
	//	DDV_MinMaxInt(pDX, m_nCPort, 1, 65535);
	DDX_Text(pDX, IDC_EDIT5, m_nVPort);
	//	DDV_MinMaxInt(pDX, m_nVPort, 1, 65535);
	DDX_Text(pDX, IDC_EDIT6, m_nHPort);
	//	DDV_MinMaxInt(pDX, m_nHPort, 1, 65535);
	DDX_Text(pDX, IDC_EDIT7, m_szUserName);
	//	DDV_MaxChars(pDX, m_szUserName, 32);
	DDX_Text(pDX, IDC_EDIT8, m_szPassword);
	//	DDV_MaxChars(pDX, m_szPassword, 32);
	DDX_Control(pDX, IDC_COMBO1, m_oName);
	DDX_Text(pDX, IDC_EDIT10, m_szCameraName);
	DDX_Control(pDX, IDC_CHECK1, m_Check_PTZ);
	DDX_Control(pDX, IDC_CHECK3, m_Check_GIP);
	DDX_Control(pDX, IDC_CHECK2, m_Check_Quad);
	DDX_Control(pDX, IDC_COMBO2, m_TCPType);
	DDX_Control(pDX, IDC_CHECK5, m_Check_DCN);
	DDX_Control(pDX, IDC_CHECK4, m_Check_DME);
}

BEGIN_MESSAGE_MAP(CMobileExplorerDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMobileExplorerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMobileExplorerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON4, &CMobileExplorerDlg::OnBnClickedButton4)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CMobileExplorerDlg::OnCbnSelchangeCombo1)
	ON_BN_CLICKED(IDC_CHECK1, &CMobileExplorerDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK3, &CMobileExplorerDlg::OnBnClickedCheck3)
	ON_BN_CLICKED(IDC_BUTTON3, &CMobileExplorerDlg::OnBnClickedSetToDefault)
	ON_BN_CLICKED(IDC_CHECK2, &CMobileExplorerDlg::OnBnClickedCheck2)
	ON_EN_CHANGE(IDC_EDIT2, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT3, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT4, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT5, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT6, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT7, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT8, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT9, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT10, &CMobileExplorerDlg::OnEnChangeEdit10)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CMobileExplorerDlg::OnCbnSelchangeCombo2)
	ON_BN_CLICKED(IDC_CHECK5, &CMobileExplorerDlg::OnBnClickedCheck5)
	ON_BN_CLICKED(IDC_CHECK4, &CMobileExplorerDlg::OnBnClickedCheck4)
END_MESSAGE_MAP()


// CMobileExplorerDlg message handlers

BOOL CMobileExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
//	m_MicPhone.OpenMicPhone( true );
//	m_MicMute.MuteMicPhone( false );
//	DWORD dw = m_MicVolume.GetVolume();
//	m_MicVolume.SetVolume(dw);
	/*
	CFont fn;
	fn.CreateFont(
		8,                        // nHeight
		0,                         // nWidth
		0,                         // nEscapement
		0,                         // nOrientation
		FW_NORMAL,                 // nWeight
		FALSE,                     // bItalic
		FALSE,                     // bUnderline
		0,                         // cStrikeOut
		ANSI_CHARSET,              // nCharSet
		OUT_DEFAULT_PRECIS,        // nOutPrecision
		CLIP_DEFAULT_PRECIS,       // nClipPrecision
		DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
		_T("Arial"));                 // lpszFacename

	SetFont( &fn );
	*/
	WSADATA wsaData;
	WSAStartup( MAKEWORD( 2, 2 ), &wsaData );

	DEVMODE devmode = {0};
	devmode.dmSize = sizeof(DEVMODE);
	devmode.dmDisplayOrientation = DMDO_0;
	devmode.dmFields = DM_DISPLAYORIENTATION;
	ChangeDisplaySettingsEx(NULL, &devmode, NULL, 0, NULL);

	char szIndex[16];

	for( int i = 0; i< 16; i++ )
	{
		sprintf( szIndex, "%d\0", i + 1 );
		m_oName.InsertString( i, (CString)szIndex );
	}

	m_oName.SetCurSel(0);
	m_TCPType.InsertString( 0, L"1.0" );
	m_TCPType.InsertString( 1, L"2.0" );
	m_TCPType.InsertString( 2, L"NVR" );
	m_nTCPType = 2;
	m_nUseIndex = 0;
	/*
	MOBILE_MEDIA_SETTING mms;
	memset( &mms, 0, sizeof(MOBILE_MEDIA_SETTING) );
	memcpy( &mms, m_MCM.GetValue( m_nUseIndex ), sizeof(MOBILE_MEDIA_SETTING));
	*/
	UpdateUIWithMobileMediaSetting( m_MCM.GetValue( m_nUseIndex ) );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMobileExplorerDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MOBILEEXPLORER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MOBILEEXPLORER_DIALOG));
}
#endif


void CMobileExplorerDlg::OnBnClickedButton1()
{
	UpdateData();
	if( m_bSettingChanged )
	{
		if( ::MessageBox( m_hWnd, _T("Setting Changed! Apply?"), _T("Setting Changed"), MB_YESNO ) == IDYES )
		{
			if( SaveMobileMediaSetting( m_nUseIndex ) )
				::MessageBox( m_hWnd, _T("OK"), _T("Apply Setting"), MB_OK );
			else
				::MessageBox( m_hWnd, _T("Fail"), _T("Apply Setting"), MB_OK );
		}
		m_bSettingChanged = false;
	}
	// Connect
	int nIndex = m_oName.GetCurSel();
	//memcpy( &mms, m_MCM.GetValue( nIndex ), sizeof(MOBILE_MEDIA_SETTING));

	CWideVideoDlg dlg;
	if( nIndex >= 0 && nIndex < 16 )//strlen(mms.szCameraName) > 0 )
	{
		for( int n = 0; n < 16; n++ )
		{
			//MOBILE_MEDIA_SETTING mms;
			//memcpy( &mms, m_MCM.GetValue( n ), sizeof(MOBILE_MEDIA_SETTING));
			dlg.FillMobileVideoSetting( n, m_MCM.GetValue( n ) );
		}
		dlg.SetStartPatrolIndex( nIndex );
		//dlg.SetMobileVideoSetting( &mms );

		//DDX_Control(pDX, IDC_COMBO1, m_oName);
		GetDlgItem( IDC_BUTTON1  )->EnableWindow( FALSE );
		GetDlgItem( IDC_BUTTON2  )->EnableWindow( FALSE );
		GetDlgItem( IDC_BUTTON3  )->EnableWindow( FALSE );
		GetDlgItem( IDC_BUTTON4  )->EnableWindow( FALSE );
		GetDlgItem( IDC_COMBO1 )->EnableWindow( FALSE );
		dlg.DoModal();
		for( int i = 0; i < 16; i++ )
		{
			MOBILE_MEDIA_SETTING *p =  m_MCM.GetValue( i );
			m_MCM.SetValue( p );
		}
		
		GetDlgItem( IDC_BUTTON1  )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON2  )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON3  )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON4  )->EnableWindow( TRUE );
		GetDlgItem( IDC_COMBO1 )->EnableWindow( TRUE );
	}
}

void CMobileExplorerDlg::OnBnClickedButton2()
{
	// Save
	GetDlgItem( IDC_BUTTON2 )->EnableWindow( 0 );
	UpdateData();
	if( SaveMobileMediaSetting( m_nUseIndex ) )
		::MessageBox( m_hWnd, _T("OK"), _T("Apply Setting"), MB_OK );

	else
		::MessageBox( m_hWnd, _T("Fail"), _T("Apply Setting"), MB_OK );
	GetDlgItem( IDC_BUTTON2 )->EnableWindow( 1 );
}

void CMobileExplorerDlg::OnBnClickedButton4()
{
	// Exit
	UpdateData();
	if( m_bSettingChanged )
	{
		if( ::MessageBox( m_hWnd, _T("Setting Changed! Apply?"), _T("Setting Changed"), MB_YESNO ) == IDYES )
		{
			if( SaveMobileMediaSetting( m_nUseIndex ) )
				::MessageBox( m_hWnd, _T("OK"), _T("Apply Setting"), MB_OK );
			else
				::MessageBox( m_hWnd, _T("Fail"), _T("Apply Setting"), MB_OK );
		}
		m_bSettingChanged = false;
	}
	CMobileExplorerDlg::OnCancel();
}


char * CMobileExplorerDlg::myWideCharToMultiByte( BSTR orgString, int nLen )
{
	int nfinalLen = WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK, orgString, nLen, m_szMultiByte, 1024, NULL, NULL);
	m_szMultiByte[ nfinalLen ] = 0;
	return m_szMultiByte;
}
void CMobileExplorerDlg::OnCbnSelchangeCombo1()
{
	UpdateData();
	if( m_bSettingChanged )
	{
		if( ::MessageBox( m_hWnd, _T("Setting Changed! Apply?"), _T("Setting Changed"), MB_YESNO ) == IDYES )
		{
			if( SaveMobileMediaSetting( m_nUseIndex ) )
				::MessageBox( m_hWnd, _T("OK"), _T("Apply Setting"), MB_OK );
			else
				::MessageBox( m_hWnd, _T("Fail"), _T("Apply Setting"), MB_OK );
		}
		m_bSettingChanged = false;
	}
	
	m_nUseIndex = m_oName.GetCurSel();
	UpdateUIWithMobileMediaSetting( m_MCM.GetValue( m_nUseIndex ) );
}


void CMobileExplorerDlg::OnBnClickedCheck1()
{
	// Check PTZ
	UpdateData();
	if( m_Check_PTZ.GetCheck() == BST_CHECKED )
	{
		if( GetPTZProtocolFileName( m_hWnd ) )
		{
			m_bPTZChecked = true;
			m_nPTZSourceType		= 1;
			m_szVender				= L"";
			m_szProtocol			= L"";

			CPTZAddressIDDlg ptzAddIDDlg;
			ptzAddIDDlg.m_AddressID = m_nPTZAddressID;
			ptzAddIDDlg.DoModal();
			m_nPTZAddressID = ptzAddIDDlg.m_AddressID;

			CRS232SettingDlg rs232SettingDgl;
			rs232SettingDgl.m_CONTROL = m_nSerialControl;
			rs232SettingDgl.m_RATE = m_nSerialRate;
			rs232SettingDgl.DoModal();
			m_nSerialControl = rs232SettingDgl.m_CONTROL;
			m_nSerialRate = rs232SettingDgl.m_RATE;
		}

		else
		{
			m_nSerialControl = 0;
			m_nSerialRate = 0;
			m_nPTZSourceType		= 0;
			m_szVender				= L"";
			m_szProtocol			= L"";
			m_szProtocolFileName	= L"";
			m_bPTZChecked = false;
			m_Check_PTZ.SetCheck( BST_UNCHECKED );
			UpdateData( FALSE );
		}
	}

	else
		m_bPTZChecked = false;
	m_bSettingChanged = true;
}

void CMobileExplorerDlg::OnBnClickedCheck3()
{
	// Check Group Into Patrol
	UpdateData();
	if( m_Check_GIP.GetCheck() == BST_CHECKED )
	{
		m_bGIPChecked = true;
	}

	else
	{
		m_bGIPChecked = false;
	}
	m_bSettingChanged = true;
}

BOOL CMobileExplorerDlg::GetPTZProtocolFileName(HWND hwndOwner)
{
	TCHAR	szPFN[512];
	TCHAR	tIniPath[512];

	OPENFILENAMEEX ofnex = {0};
	ofnex.lpstrFile       = szPFN;
	ofnex.lStructSize     = sizeof(OPENFILENAMEEX);
	ofnex.hwndOwner       = hwndOwner;
	ofnex.nMaxFile        = sizeof(szPFN)/sizeof(szPFN[0]);
	ofnex.lpstrFilter     = TEXT("PTZ Protocol Files (*.ptz)\0*.ptz\0");
	ofnex.lpstrTitle      = TEXT("SELECTION - PTZ Protocol File ");
	ofnex.ExFlags         = OFN_EXFLAG_DETAILSVIEW;
	
	wsprintf( tIniPath, L"\\Program files\\MobileExplorer\\protocol" );
	ofnex.lpstrInitialDir = tIniPath;
	BOOL bRet = GetOpenFileNameEx(&ofnex);
	m_szProtocolFileName = szPFN;
	return bRet;
}

bool CMobileExplorerDlg::SaveMobileMediaSetting( int nIndex )
{
	MOBILE_MEDIA_SETTING mms;
	memset( &mms, 0, sizeof(MOBILE_MEDIA_SETTING) );

	mms.nIndexNO = nIndex;

	// Camera Setting
	sprintf( mms.szCameraName, "%s\0", myWideCharToMultiByte(m_szCameraName.GetBuffer(),m_szCameraName.GetLength()) );
	m_szCameraName.ReleaseBuffer();
	sprintf( mms.szCameraIP, "%s\0", myWideCharToMultiByte(m_szCameraIP.GetBuffer(),m_szCameraIP.GetLength()) );
	m_szCameraIP.ReleaseBuffer();
	mms.nRegisterPort = m_nRPort;
	mms.nControlPort = m_nCPort;
	mms.nStreamingPort = m_nVPort;
	mms.nHTTPPort = m_nHPort;
	sprintf( mms.szUserName, "%s\0", myWideCharToMultiByte(m_szUserName.GetBuffer(),m_szUserName.GetLength()) );
	m_szUserName.ReleaseBuffer();
	sprintf( mms.szPassword, "%s\0", myWideCharToMultiByte(m_szPassword.GetBuffer(),m_szPassword.GetLength()) );
	m_szPassword.ReleaseBuffer();

	// Streaming Engine Setting
	mms.bUsingStreamingEngine = m_bUseConnectToNVR;
	sprintf( mms.szStreamingEngineIP, "%s\0", myWideCharToMultiByte(m_szStreamingEngineIP.GetBuffer(), m_szStreamingEngineIP.GetLength()) );
	m_szStreamingEngineIP.ReleaseBuffer();
	sprintf( mms.szStreamingEngineUserName, "%s\0", myWideCharToMultiByte(m_szStreamingEngineUser.GetBuffer(), m_szStreamingEngineUser.GetLength()) );
	m_szStreamingEngineUser.ReleaseBuffer();
	sprintf( mms.szStreamingEnginePassword, "%s\0", myWideCharToMultiByte(m_szStreamingEnginePassword.GetBuffer(), m_szStreamingEnginePassword.GetLength()) );
	m_szStreamingEnginePassword.ReleaseBuffer();

	mms.nStreamingEngineControlPort = m_nStreamingEngineCPort;
	mms.nStreamingEngineStreamingPort = m_nStreamingEngineVPort;

	// PTZ Setting 
	mms.bEnablePTZ = m_bPTZChecked;
	mms.nPTZProtocolSourceType = m_nPTZSourceType;
	sprintf( mms.szPTZVender, "%s\0", myWideCharToMultiByte(m_szVender.GetBuffer(), m_szVender.GetLength()) );
	m_szVender.ReleaseBuffer();
	sprintf( mms.szPTZProtocol, "%s\0", myWideCharToMultiByte(m_szProtocol.GetBuffer(), m_szProtocol.GetLength()) );
	m_szProtocol.ReleaseBuffer();
	sprintf( mms.szPTZProtocolFileName, "%s\0", myWideCharToMultiByte(m_szProtocolFileName.GetBuffer(), m_szProtocolFileName.GetLength()) );
	m_szProtocolFileName.ReleaseBuffer();
	mms.bGroupIntoPatrol = m_bGIPChecked;
	mms.bPlayAudio = m_bPlayAudioChecked;
	mms.bQuad = m_bQuadChecked;
	mms.bShowCameraName = m_bDCNChecked;
	mms.bShowEvent = m_bShowEventChecked;

	mms.nSerialControl = m_nSerialControl;
	mms.nSerialBaudRate = m_nSerialRate;
	m_bSettingChanged = false;
	mms.nPTZAddressID = m_nPTZAddressID;
	mms.nTCPType = m_nTCPType;
	return m_MCM.SetValue( &mms );
}


void CMobileExplorerDlg::UpdateUIWithMobileMediaSetting( MOBILE_MEDIA_SETTING *pMediaSetting )
{
	m_szCameraName	= (CString)pMediaSetting->szCameraName;
	m_szCameraIP	= (CString)pMediaSetting->szCameraIP;
	m_dwChannelNO	= pMediaSetting->nChannelNO;
	m_nRPort		= pMediaSetting->nRegisterPort;
	m_nCPort		= pMediaSetting->nControlPort;
	m_nVPort		= pMediaSetting->nStreamingPort;
	m_nHPort		= pMediaSetting->nHTTPPort;
	m_szUserName	= (CString)pMediaSetting->szUserName;
	m_szPassword	= (CString)pMediaSetting->szPassword;

	m_bUseConnectToNVR = pMediaSetting->bUsingStreamingEngine;
	m_szStreamingEngineIP = pMediaSetting->szStreamingEngineIP;
	m_szStreamingEngineUser = pMediaSetting->szStreamingEngineUserName;
	m_szStreamingEnginePassword = pMediaSetting->szStreamingEnginePassword;
	m_nStreamingEngineCPort = pMediaSetting->nStreamingEngineControlPort;
	m_nStreamingEngineVPort = pMediaSetting->nStreamingEngineStreamingPort;

	// Change PTZ Buttons
	m_bPTZChecked = pMediaSetting->bEnablePTZ;
	m_Check_PTZ.SetCheck( m_bPTZChecked?BST_CHECKED:BST_UNCHECKED );
	//	EnablePTZButton( m_bPTZChecked );

	if( m_bPTZChecked )
	{
		m_nPTZSourceType = 1; // 0 : not use PTZ, 1 : meaning Using File, 2 : meaning Using Resource(not ready yet)
		m_szVender = L"";
		m_szProtocol = L"";
		m_szProtocolFileName = (CString)pMediaSetting->szPTZProtocolFileName;
	}
	else
	{
		m_nPTZSourceType = 0;
		m_szVender = L"";
		m_szProtocol = L"";
		m_szProtocolFileName = L"";
	}


	// Change GIP Buttons
	m_bGIPChecked = pMediaSetting->bGroupIntoPatrol;
	m_Check_GIP.SetCheck( m_bGIPChecked?BST_CHECKED:BST_UNCHECKED );

	// Change Quad Button
	m_bQuadChecked = pMediaSetting->bQuad;
	m_Check_Quad.SetCheck( m_bQuadChecked?BST_CHECKED:BST_UNCHECKED );

	// Change Show Camera Name
	m_bDCNChecked = pMediaSetting->bShowCameraName;
	m_Check_DCN.SetCheck( m_bDCNChecked?BST_CHECKED:BST_UNCHECKED );

	// Change Show Event
	m_bShowEventChecked = pMediaSetting->bShowEvent;
	m_Check_DME.SetCheck( m_bShowEventChecked?BST_CHECKED:BST_UNCHECKED );

	m_nSerialControl = pMediaSetting->nSerialControl;
	m_nSerialRate = pMediaSetting->nSerialBaudRate;
	m_nPTZAddressID = pMediaSetting->nPTZAddressID;

	m_nTCPType = pMediaSetting->nTCPType;
	if( m_nTCPType == 2 )
		m_TCPType.SetCurSel(1);
	else if( m_nTCPType == 1 )
		m_TCPType.SetCurSel(0);
	else if( m_nTCPType == 3 )
		m_TCPType.SetCurSel(2);

	UpdateData( FALSE );
}

void CMobileExplorerDlg::OnBnClickedSetToDefault()
{
	MOBILE_MEDIA_SETTING mms;

	memset( &mms, 0, sizeof(MOBILE_MEDIA_SETTING));
	mms.nIndexNO = m_nUseIndex;

	mms.nChannelNO = 0;
	// Camera Setting
	sprintf( mms.szCameraName, "Camera - %d\0", m_nUseIndex + 1 );
	sprintf( mms.szCameraIP, "192.168.0.100\0" );
	mms.nRegisterPort = 6000;
	mms.nControlPort = 6001;
	mms.nStreamingPort = 6002;
	mms.nHTTPPort = 80;
	sprintf( mms.szUserName, "Admin\0" );
	sprintf( mms.szPassword, "123456\0" );

	// Streaming Engine Setting
	mms.bUsingStreamingEngine = false;
	sprintf( mms.szStreamingEngineIP, "\0" );
	sprintf( mms.szStreamingEngineUserName, "\0" );
	sprintf( mms.szStreamingEnginePassword, "\0" );
	// PTZ Setting 
	mms.bEnablePTZ = false;
	mms.nPTZProtocolSourceType = 0;
	sprintf( mms.szPTZVender, "\0" );
	sprintf( mms.szPTZProtocol, "\0" );
	sprintf( mms.szPTZProtocolFileName, "\0" );

	//Group Patrol
	mms.bGroupIntoPatrol = false;

	// Play Audio
	mms.bPlayAudio = false;

	// Show Camera Name
	mms.bShowCameraName = false;

	// Show Event
	mms.bShowEvent = false;
	
	mms.nTCPType = 2;
	mms.nPTZAddressID = 1;
	mms.nPTZSpeed = 3;
	UpdateUIWithMobileMediaSetting( &mms );
	m_bSettingChanged = true;
}

void CMobileExplorerDlg::OnBnClickedCheck2()
{
	UpdateData();
	if( m_Check_Quad.GetCheck() == BST_CHECKED )
		m_bQuadChecked = true;
	else
		m_bQuadChecked = false;
	UpdateData( FALSE );
	m_bSettingChanged = true;
}

void CMobileExplorerDlg::OnEnChangeEdit10()
{
	m_bSettingChanged = true;
}

void CMobileExplorerDlg::OnCbnSelchangeCombo2()
{
	UpdateData();
	int nSel = m_TCPType.GetCurSel();
	if( nSel == 0 )
		m_nTCPType = STREAMING_TYPE_ATCP10;
	else if( nSel == 1 )
		m_nTCPType = STREAMING_TYPE_ATCP20;
	else if( nSel == 2 )
	{
		CSEConfigDlg dlg;
		dlg.m_szNVRIP = m_szStreamingEngineIP ;
		dlg.m_szUserName = m_szStreamingEngineUser;
		dlg.m_szPassword = m_szStreamingEnginePassword;
		dlg.m_nCPort = m_nStreamingEngineCPort;
		dlg.m_nVPort = m_nStreamingEngineVPort;

		dlg.DoModal();
		m_nTCPType = STREAMING_TYPE_NVR;

		m_bUseConnectToNVR = true;
		m_szStreamingEngineIP = dlg.m_szNVRIP;
		m_szStreamingEngineUser = dlg.m_szUserName;
		m_szStreamingEnginePassword = dlg.m_szPassword;
		m_nStreamingEngineCPort = dlg.m_nCPort;
		m_nStreamingEngineVPort = dlg.m_nVPort;
	}
	else
		m_nTCPType = STREAMING_TYPE_ATCP20; // Default
	m_bSettingChanged = true;
}

void CMobileExplorerDlg::OnBnClickedCheck5()
{
	UpdateData();
	if( m_Check_DCN.GetCheck() == BST_CHECKED )
		m_bDCNChecked = true;
	else
		m_bDCNChecked = false;
	UpdateData( FALSE );
	m_bSettingChanged = true;	
}

void CMobileExplorerDlg::OnBnClickedCheck4()
{
	UpdateData();
	if( m_Check_DME.GetCheck() == BST_CHECKED )
		m_bShowEventChecked = true;
	else
		m_bShowEventChecked = false;
	UpdateData( FALSE );
	m_bSettingChanged = true;
}
