// RS232SettingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MobileExplorer.h"
#include "RS232SettingDlg.h"


// CRS232SettingDlg dialog

IMPLEMENT_DYNAMIC(CRS232SettingDlg, CDialog)

CRS232SettingDlg::CRS232SettingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRS232SettingDlg::IDD, pParent)
{
	m_CONTROL = 0;
	m_RATE = 0;
}

CRS232SettingDlg::~CRS232SettingDlg()
{
}

void CRS232SettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_control);
	DDX_Control(pDX, IDC_COMBO2, m_rate);
}


BEGIN_MESSAGE_MAP(CRS232SettingDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CRS232SettingDlg::OnBnClickedOk)
END_MESSAGE_MAP()

void CRS232SettingDlg::OnBnClickedOk()
{
	UpdateData();
	int nSel = m_control.GetCurSel();
	switch( nSel )
	{
	case 0:
		m_CONTROL = 0x00;
		break;
	case 1:
		m_CONTROL = 0x08;
	    break;
	case 2:
		m_CONTROL = 0x18;
	    break;
	default:
		m_CONTROL = 0x00;
		break;
	}
	m_RATE = m_rate.GetCurSel();
	UpdateData( FALSE );
	OnOK();
}

/*
#define NET_N81			0x00		// N,    8, 1
#define NET_O81			0x08		// Odd,  8, 1
#define NET_E81			0x18		// Even, 8, 1
#define NET_1200BPS		0X00
#define NET_2400BPS		0X01
#define NET_4800BPS		0X02
#define NET_9600BPS		0X03
#define NET_19200BPS	0X04
#define NET_38400BPS	0X05
#define NET_57600BPS	0X06
#define NET_115200BPS	0X07
#define NET_230400BPS	0X08
*/
void CRS232SettingDlg::UpdateUI()
{
	switch( m_CONTROL )
	{
	case 0x00:
		m_control.SetCurSel( 0 );
		break;
	case 0x08:
		m_control.SetCurSel( 1 );
		break;
	case 0x18:
		m_control.SetCurSel( 2 );
		break;
	}
	m_rate.SetCurSel( (int)m_RATE );
	UpdateData( FALSE );
}

BOOL CRS232SettingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_control.InsertString( 0, L"8, None, 1\0" );
	m_control.InsertString( 1, L"8, Odd, 1\0" );
	m_control.InsertString( 2, L"8, Even, 1\0" );
	m_rate.InsertString( 0, L"1200\0" );
	m_rate.InsertString( 1, L"2400\0" );
	m_rate.InsertString( 2, L"4800\0" );
	m_rate.InsertString( 3, L"9600\0" );
	m_rate.InsertString( 4, L"19200\0" );
	m_rate.InsertString( 5, L"38400\0" );
	m_rate.InsertString( 6, L"57600\0" );
	m_rate.InsertString( 7, L"115200\0" );
	m_rate.InsertString( 8, L"230400\0" );
	UpdateUI();
	return TRUE;  // return TRUE  unless you set the focus to a control
}