// WideVideoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MobileExplorer.h"
#include "WideVideoDlg.h"

// CWideVideoDlg dialog
#define _MY_EVENT_TIMER 1001
#define WM_HAVETOCLOSE 1002

#define PROG_RANG 450
#define PROG_TIME 100
DWORD WINAPI myCounter( LPVOID lp )
{
	((CWideVideoDlg*)lp)->Counter();
	return 0;
}
DWORD WINAPI myConnecter( LPVOID lp )
{
	((CWideVideoDlg*)lp)->Connecter();
	return 0;
}
DWORD WINAPI myConnecterPatrol( LPVOID lp )
{
	((CWideVideoDlg*)lp)->ConnecterPatrol();
	return 0;
}
void CALLBACK myAFTER_RENDER_CALLBACK( DWORD UserParam )
{
	((CWideVideoDlg*)UserParam)->AfterRender();
}

void CALLBACK myNETWORK_LOSS_CALLBACK( DWORD UserParam )
{
	((CWideVideoDlg*)UserParam)->NetWorkLoss();
}

void CALLBACK myMOTION_DETECTION_CALLBACK( DWORD UserParam, bool Motion1, bool Motion2, bool Motion3, bool Motion4 )
{
	((CWideVideoDlg*)UserParam)->MotionDetection( Motion1, Motion2, Motion3, Motion4 );
}

void CALLBACK myDI_CALLBACK( DWORD UserParam, bool DI1, bool DI2 )
{
	((CWideVideoDlg*)UserParam)->DigitalIn( DI1, DI2 );
}

IMPLEMENT_DYNAMIC(CWideVideoDlg, CDialog)

CWideVideoDlg::CWideVideoDlg(CWnd* pParent /*=NULL*/)
: CBDialog(CWideVideoDlg::IDD, pParent)
{
	m_bEnableSE = false;
	m_nPatrolStart = 0;
	m_bPlaying = false;
	m_bShowCameraName = false;
	m_hDrawInfo = NULL;
	m_bEnablePTZOSD = false;
	m_bMotion[0] = false;
	m_bMotion[1] = false;
	m_bMotion[2] = false;
	m_bMotion[3] = false;
}

CWideVideoDlg::~CWideVideoDlg()
{
}

void CWideVideoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS1, m_myProgressCtrl);
	DDX_Control(pDX, IDC_CAMERANAME, m_stCameraName);
}


BEGIN_MESSAGE_MAP(CWideVideoDlg, CDialog)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY_REFLECT(NM_RECOGNIZEGESTURE, OnRecognizeGesture)
END_MESSAGE_MAP()


// CWideVideoDlg message handlers
BOOL CWideVideoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	WORD wVersionRequested;
	WSADATA wsaData;
	wVersionRequested=MAKEWORD( 2, 2 );
	WSAStartup( wVersionRequested, &wsaData );
	
	GetDlgItem( IDC_MOTION1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_MOTION2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_MOTION3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_MOTION4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_DI1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_DI2 )->ShowWindow( SW_HIDE );

	m_stCameraName.ShowWindow( SW_HIDE );

	GetDlgItem( IDC_PTZ_UP )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_DOWN )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_LEFT )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_RIGHT )->ShowWindow( SW_HIDE );

	GetDlgItem( IDC_PTZ_UPLEFT )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_UPRIGHT )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_DOWNLEFT )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_DOWNRIGHT )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_ZOOMIN )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PTZ_ZOOMOUT )->ShowWindow( SW_HIDE );



	DEVMODE devmode = {0};
	devmode.dmSize = sizeof(DEVMODE);
	devmode.dmDisplayOrientation = DMDO_270;
	devmode.dmFields = DM_DISPLAYORIENTATION;
	ChangeDisplaySettingsEx(NULL, &devmode, NULL, 0, NULL);

	SetBitmapStyle(StyleCenter);
	//SetBitmap(IDB_BITMAP1);
	m_nScreenWidth = ::GetSystemMetrics(SM_CXSCREEN);
	m_nScreenHeight = ::GetSystemMetrics(SM_CYSCREEN);
	SHFullScreen(m_hWnd,SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);
	HWND m_hMenuBar = SHFindMenuBar(m_hWnd);
	SHSipPreference(m_hMenuBar,SIP_FORCEDOWN);
	::ShowWindow(m_hMenuBar,SW_HIDE);
	SetWindowPos(NULL,0,0,m_nScreenWidth,m_nScreenHeight,SWP_SHOWWINDOW|SWP_NOZORDER);
	AfxGetMainWnd()->SetForegroundWindow(); 
	//m_myProgressCtrl.SetWindowPos( NULL, (m_nScreenWidth/2)-(200/2), (m_nScreenHeight/2)-(10/2), 200, 10, SWP_SHOWWINDOW  );
	m_myProgressCtrl.SetWindowPos( NULL, 25, (m_nScreenHeight)-(21), 150, 10, SWP_SHOWWINDOW  );
	m_hDrawInfo = CreateEvent( NULL, TRUE, FALSE, NULL );
	SetEvent( m_hDrawInfo );
	m_Menu.LoadMenu( IDR_MENU1 );
	SetTimer( _MY_EVENT_TIMER, 1000, NULL );
	ConnectChannel( m_nPatrolStart, false );
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CWideVideoDlg::OnClose()
{
	KillTimer( _MY_EVENT_TIMER );
	SetBitmap(IDB_BITMAP2);
	DisConnectChannel();
	DEVMODE devmode = {0};
	devmode.dmSize = sizeof(DEVMODE);
	devmode.dmDisplayOrientation = DMDO_0;
	devmode.dmFields = DM_DISPLAYORIENTATION;
	ChangeDisplaySettingsEx(NULL, &devmode, NULL, 0, NULL);

	CloseHandle( m_hDrawInfo );
	m_hDrawInfo = NULL;
	CDialog::OnClose();
}

void CWideVideoDlg::OnOK()
{
	if( m_bGoCount ) return;
	m_Menu.GetSubMenu(0)->TrackPopupMenu( TPM_RIGHTALIGN, 0, 0, CWnd::FromHandle( m_hWnd ), CRect(0,0,0,0) );
}

LRESULT CWideVideoDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	//char msg[32];
	//sprintf( msg, "0x%X-0x%X-0x%X\n", message, wParam,lParam );
	//OutputDebugString( (CString)msg );
	switch( message )
	{
	case WM_TIMER:
		if( wParam == _MY_EVENT_TIMER )
		{
			if( m_MMS->bShowEvent )
			{
				GetDlgItem( IDC_MOTION1 )->ShowWindow( m_bMotion[0] ? SW_SHOW : SW_HIDE );
				GetDlgItem( IDC_MOTION2 )->ShowWindow( m_bMotion[1] ? SW_SHOW : SW_HIDE );
				GetDlgItem( IDC_MOTION3 )->ShowWindow( m_bMotion[2] ? SW_SHOW : SW_HIDE );
				GetDlgItem( IDC_MOTION4 )->ShowWindow( m_bMotion[3] ? SW_SHOW : SW_HIDE );
				GetDlgItem( IDC_DI1 )->ShowWindow( m_bDI[0] ? SW_SHOW : SW_HIDE );
				GetDlgItem( IDC_DI2 )->ShowWindow( m_bDI[1] ? SW_SHOW : SW_HIDE );
				m_bMotion[0] = false;
				m_bMotion[1] = false;
				m_bMotion[2] = false;
				m_bMotion[3] = false;
				m_bDI[0] = false;
				m_bDI[1] = false;
			}
		}
		break;
	case WM_LBUTTONDOWN:
		{
			int nx = LOWORD(lParam);
			int ny = HIWORD(lParam);
			Reaction_LBUTTONDOWN( nx, ny );
			m_bEnableMouseMove = true;
		}
		break;
	case WM_LBUTTONUP:
		{
			int x = LOWORD(lParam);
			int y = HIWORD(lParam); 
			Reaction_LBUTTONUP( x, y );
			m_bEnableMouseMove = false;
		}
		break;
	case WM_MOUSEMOVE:
		{
			if( m_bEnableMouseMove )
			{
				int x = LOWORD(lParam);
				int y = HIWORD(lParam);
				Reaction_MOUSEMOVE( x, y );
			}
		}
	case WM_KEYDOWN:
		Reaction_KEYDOWN( wParam );
		break;
	case WM_KEYUP:
		Reaction_KEYUP( wParam );
		break;

	case WM_COMMAND:
		{
			WORD wCommandID = LOWORD(wParam);
			switch( wCommandID )
			{
			case ID_VARIABLEFPS_FPS1:
				if( m_hSDK ) M_KSetVariableFPS( m_hSDK, 1 );
				break;
			case ID_VARIABLEFPS_FPS3:
				if( m_hSDK ) M_KSetVariableFPS( m_hSDK, 3 );
				break;
			case ID_VARIABLEFPS_FPS5:
				if( m_hSDK ) M_KSetVariableFPS( m_hSDK, 5 );
				break;
			case ID_VARIABLEFPS_FPS6:
				if( m_hSDK ) M_KSetVariableFPS( m_hSDK, 6 );
				break;
			case ID_VARIABLEFPS_FPS25:
				if( m_hSDK ) M_KSetVariableFPS( m_hSDK, 25 );
				break;
			case ID_VARIABLEFPS_FPS30:
				if( m_hSDK ) M_KSetVariableFPS( m_hSDK, 30 );
				break;
			case ID_PTZSPEED_SPEED1:
				{
					m_MMS->nPTZSpeed = 1;
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1, MF_CHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED2, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED3, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED4, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED5, MF_UNCHECKED );
				}
				break;
			case ID_PTZSPEED_SPEED2:
				{
					m_MMS->nPTZSpeed = 2;
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED2, MF_CHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED3, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED4, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED5, MF_UNCHECKED );
				}
				break;
			case ID_PTZSPEED_SPEED3:
				{
					m_MMS->nPTZSpeed = 3;
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED2, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED3, MF_CHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED4, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED5, MF_UNCHECKED );
				}
				break;
			case ID_PTZSPEED_SPEED4:
				{
					m_MMS->nPTZSpeed = 4;
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED2, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED3, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED4, MF_CHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED5, MF_UNCHECKED );
				}
				break;
			case ID_PTZSPEED_SPEED5:
				{
					m_MMS->nPTZSpeed = 5;
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED2, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED3, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED4, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED5, MF_CHECKED );
				}
				break;
			case ID_PTZOSD_ON:
				{
					m_bEnablePTZOSD = true;
					if( m_hSDK && m_MMS->bEnablePTZ )
						M_KPTZ_OSD_ON( m_hSDK );
					//m_Menu.CheckMenuItem( ID_PTZOSD_ON, MF_CHECKED );
					//m_Menu.CheckMenuItem( ID_PTZOSD_OFF, MF_UNCHECKED );
				}
				break;
			case ID_PTZOSD_OFF:
				{
					if( m_hSDK && m_MMS->bEnablePTZ )
						M_KPTZ_OSD_OFF( m_hSDK );
					m_bEnablePTZOSD = false;
					//m_Menu.CheckMenuItem( ID_PTZOSD_ON, MF_UNCHECKED );
					//m_Menu.CheckMenuItem( ID_PTZOSD_OFF, MF_CHECKED );
				}
				break;
			case ID_AUDIO_ON:
				{
					m_MMS->bPlayAudio = true;
					if( m_hSDK ) M_KSetMute( m_hSDK, true );

					m_Menu.CheckMenuItem( ID_AUDIO_ON, MF_CHECKED );
					m_Menu.CheckMenuItem( ID_AUDIO_OFF, MF_UNCHECKED );
				}
				break;
			case ID_AUDIO_OFF:
				{
					m_MMS->bPlayAudio = false;
					if( m_hSDK ) M_KSetMute( m_hSDK, false );
					m_Menu.CheckMenuItem( ID_AUDIO_ON, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_AUDIO_OFF, MF_CHECKED );
				}
				break;
			case ID_POPUP_STOP:
				{
					PostMessage( WM_CLOSE, 0, 0 );
				}
				break;
			case ID_PTZPRESET_GOTO_PRESET1:
			case ID_PTZPRESET_GOTO_PRESET2:
			case ID_PTZPRESET_GOTO_PRESET3:
			case ID_PTZPRESET_GOTO_PRESET4:
			case ID_PTZPRESET_GOTO_PRESET5:
			case ID_PTZPRESET_GOTO_PRESET6:
			case ID_PTZPRESET_GOTO_PRESET7:
			case ID_PTZPRESET_GOTO_PRESET8:
				if( m_hSDK ) 
					M_KPTZ_GOTO_PRESET( m_hSDK, wCommandID - ID_PTZPRESET_GOTO_PRESET1 + 1 );
				break;
			case ID_PTZSETPRESET_SETTOPRESET1:
			case ID_PTZSETPRESET_SETTOPRESET2:
			case ID_PTZSETPRESET_SETTOPRESET3:
			case ID_PTZSETPRESET_SETTOPRESET4:
			case ID_PTZSETPRESET_SETTOPRESET5:
			case ID_PTZSETPRESET_SETTOPRESET6:
			case ID_PTZSETPRESET_SETTOPRESET7:
			case ID_PTZSETPRESET_SETTOPRESET8:
				if( m_hSDK ) 
					M_KPTZ_SET_PRESET( m_hSDK, wCommandID - ID_PTZSETPRESET_SETTOPRESET1 + 1 );
				break;
			case ID_QAUDSWITCH_DISPLAYMONITOR1:
				if( m_hSDK && m_MMS->bQuad )
					M_KQuadSetDisplayMode( m_hSDK, 1 );
				break;
			case ID_QAUDSWITCH_DISPLAYMONITOR2:
				if( m_hSDK && m_MMS->bQuad )
					M_KQuadSetDisplayMode( m_hSDK, 2 );
				break;
			case ID_QAUDSWITCH_DISPLAYMONITOR3:
				if( m_hSDK && m_MMS->bQuad ) 
					M_KQuadSetDisplayMode( m_hSDK, 3 );
				break;
			case ID_QAUDSWITCH_DISPLAYMONITOR4:
				if( m_hSDK && m_MMS->bQuad ) 
					M_KQuadSetDisplayMode( m_hSDK, 4 );
				break;
			case ID_QAUDSWITCH_MONITORQUAD:
				if( m_hSDK && m_MMS->bQuad ) 
					M_KQuadSetDisplayMode( m_hSDK, 0 );
				break;
			case ID_AUDIO_ON32817:
				// On
				{
					if( m_MMS->nTCPType == 2 )
					{
						char Holder[32];
						if( M_KGetAudioToken(m_hSDK, Holder) )
						{
							if( !M_KStartAudioTransfer( m_hSDK ) )
							{
								::MessageBox( m_hWnd, L"Audio Out Fail!", L"2-Way Audio", MB_OK );
								M_KStopAudioTransfer( m_hSDK );
								M_KFreeAudioToken( m_hSDK );
							}

							else
							{
								m_Menu.CheckMenuItem( ID_AUDIO_ON32817, MF_CHECKED );
								m_Menu.CheckMenuItem( ID_AUDIO_OFF32818, MF_UNCHECKED );
							}
						}

						else
						{
							M_KFreeAudioToken( m_hSDK );
							char failmsg[128];
							sprintf( failmsg, "Get Audio Out Token Fail!\n %s Take It!\0", Holder );
							wchar_t *pmsg = ASCIItoUNICODE( failmsg );
							::MessageBox( m_hWnd, pmsg, L"2-Way Audio", MB_OK );
							delete [] pmsg;
						}
					}
				}

				break;
			case ID_AUDIO_OFF32818:
				// Off
				{
					M_KStopAudioTransfer( m_hSDK );
					M_KFreeAudioToken( m_hSDK );
					m_Menu.CheckMenuItem( ID_AUDIO_ON32817, MF_UNCHECKED );
					m_Menu.CheckMenuItem( ID_AUDIO_OFF32818, MF_CHECKED );
				}
				break;
			case ID_POPUP_DIGITALOUT:
				if( m_bDO1Checked )
				{
					M_KSendDO( m_hSDK, 0x00 );
					m_Menu.CheckMenuItem( ID_POPUP_DIGITALOUT, MF_UNCHECKED );
					m_bDO1Checked = false;
				}
				else
				{
					M_KSendDO( m_hSDK, 0x01 );
					m_Menu.CheckMenuItem( ID_POPUP_DIGITALOUT, MF_CHECKED );
					m_bDO1Checked = true;
				}
				break;
			}
		}
		break;
	case WM_HAVETOCLOSE:
		PostMessage( WM_CLOSE, 0, 0 );
		break;

	default:
		break;
	}
	return CDialog::WindowProc( message, wParam, lParam);
}

bool CWideVideoDlg::ExchangeHostNameToIP( char* szpHostName, char* szIPBuffer )
{
	PHOSTENT phostent;
	IN_ADDR in;
	DWORD dwIPAddr = inet_addr(szpHostName);
	if( dwIPAddr == INADDR_NONE )
	{
		phostent = gethostbyname( szpHostName );
		if( phostent )
		{
			CopyMemory( &in, phostent->h_addr, 4 );
			DWORD dwIP = inet_addr( inet_ntoa(in) );
			if( ( dwIP == INADDR_NONE ) || ( dwIP == 0 ) )
			{
				sprintf( szIPBuffer, "0.0.0.0\0" );
				return false;
			}
			sprintf( szIPBuffer, "%s\0", inet_ntoa(in) );
			return true;
		}
		else
		{
			if( strlen( szpHostName ) < 16 )
				sprintf( szIPBuffer, "%s\0", szpHostName );
			else
			{
				memcpy( szIPBuffer, szpHostName, 15 );
				szIPBuffer[15] = 0;
			}
		}
	}	
	else
	{
		if( strlen( szpHostName ) < 16 )
			sprintf( szIPBuffer, "%s\0", szpHostName );
		else
		{
			memcpy( szIPBuffer, szpHostName, 15 );
			szIPBuffer[15] = 0;
		}
	}

	return false;
}


void CWideVideoDlg::SetMobileVideoSetting( MOBILE_MEDIA_SETTING *pIn )
{
	if( pIn )
	{
		if( pIn->nControlPort > 0 && pIn->nStreamingPort > 0 && strlen(pIn->szCameraIP) > 5 )
		{
			m_MMS = pIn;
			//memcpy( &m_MMS, pIn, sizeof(MOBILE_MEDIA_SETTING));

			m_MCC.ContactType = MOBILE_CONTACT_TYPE_UNICAST_PREVIEW;//MOBILE_CONTACT_TYPE_UNICAST_PREVIEW;//MOBILE_CONTACT_TYPE_UNICAST_WOC_PREVIEW;
			m_MCC.ChannelNumber = m_MMS->nChannelNO;
			ExchangeHostNameToIP( m_MMS->szCameraIP, m_MCC.UniCastIP );
			//sprintf( m_MCC.UniCastIP, "%s\0", m_MMS->szCameraIP );
			sprintf( m_MCC.UserID, "%s\0", m_MMS->szUserName );
			sprintf( m_MCC.Password, "%s\0", m_MMS->szPassword );
			m_MCC.RegisterPort = m_MMS->nRegisterPort;
			m_MCC.ControlPort = m_MMS->nControlPort;
			m_MCC.StreamingPort = m_MMS->nStreamingPort;
			m_MCC.HTTPPort = m_MMS->nHTTPPort;
			m_MCC.ConnectTimeOut = PROG_RANG * PROG_TIME;

			ExchangeHostNameToIP( m_MMS->szStreamingEngineIP, m_SEC.szServerIP );
			//sprintf( m_SEC.szServerIP, "%s\0", m_MMS->szStreamingEngineIP );
			sprintf( m_SEC.szUserID, "%s\0", m_MMS->szStreamingEngineUserName );
			sprintf( m_SEC.szUserPwd, "%s\0", m_MMS->szStreamingEnginePassword );

			m_SEC.dwControlPort = m_MMS->nStreamingEngineControlPort;
			m_SEC.dwStreamingPort = m_MMS->nStreamingEngineStreamingPort;
			m_bEnableSE = m_MMS->bUsingStreamingEngine;
		}
	}
}
void CWideVideoDlg::Counter()
{
	m_myProgressCtrl.ShowWindow( SW_SHOW );
	while(m_bGoCount)
	{	
		if( m_nCount++ < PROG_RANG )
			m_myProgressCtrl.SetPos( m_nCount );
		Sleep( PROG_TIME );
	}
	m_myProgressCtrl.ShowWindow( SW_HIDE );
}

void CWideVideoDlg::Connecter()
{
	while(m_bGoCount)
	{	
		SetBitmap(IDB_BITMAP1);
		Invalidate();
		if( !M_KConnect( m_hSDK ) )
		{
			SetBitmap(IDB_BITMAP3);
			m_bGoCount = false;
			m_myProgressCtrl.ShowWindow( SW_HIDE );
			::MessageBox( m_hWnd, L"Connect Fail!", L"Connect", MB_OK );
			SetBitmap(IDB_BITMAP2);
			PostMessage( WM_HAVETOCLOSE, 0, 0 );
			return;
		}
		//M_KSetAfterRenderCallback( m_hSDK, (DWORD)this, myAFTER_RENDER_CALLBACK );
		//M_KSetTextout( m_hSDK, m_MMS->bShowCameraName, 10, 10, m_szCameraName );
		m_myProgressCtrl.SetPos( 100 );
		m_myProgressCtrl.ShowWindow( SW_HIDE );
		m_bPlaying = true;
		m_bGoCount = false;
		if( m_hSDK && m_MMS->bEnablePTZ )
			M_KSendRS232Setting( m_hSDK, m_MMS->nSerialControl, m_MMS->nSerialBaudRate );
	}
	m_stCameraName.ShowWindow( m_MMS->bShowCameraName ? SW_SHOW : SW_HIDE );
}

void CWideVideoDlg::ConnecterPatrol()
{
	while(m_bGoCount)
	{	
		SetBitmap(IDB_BITMAP1);
		Invalidate();
		if( !M_KConnect( m_hSDK ) )
		{
			SetBitmap(IDB_BITMAP3);
			m_bPlaying = false;
			m_bGoCount = false;
			m_myProgressCtrl.ShowWindow( SW_HIDE );
			return;
		}
		m_myProgressCtrl.SetPos( 100 );
		m_myProgressCtrl.ShowWindow( SW_HIDE );
		m_bPlaying = true;
		m_bGoCount = false;
		if( m_hSDK && m_MMS->bEnablePTZ )
			M_KSendRS232Setting( m_hSDK, m_MMS->nSerialControl, m_MMS->nSerialBaudRate );
	}
	m_stCameraName.ShowWindow( m_MMS->bShowCameraName ? SW_SHOW : SW_HIDE );
}

void CWideVideoDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	if( !m_bPlaying )
	{
		CDC *pDC = GetDC();
		if( pDC )
		{
			OnEraseBkgnd( pDC );
			ReleaseDC( pDC );
		}
	}
	SetFocus();
}

bool CWideVideoDlg::ConnectChannel( int nChannel, bool bPatrol )
{
	SetMobileVideoSetting( m_pMSSAll[nChannel] );
	m_bMotion[0] = false;
	m_bMotion[1] = false;
	m_bMotion[2] = false;
	m_bMotion[3] = false;
	m_bDI[0] = false;
	m_bDI[1] = false;

	m_hSDK = NULL;
	m_hSDK = M_KOpenInterface();

	if( m_MMS->bShowEvent )
	{
		M_KSetMotionDetectionCallback( m_hSDK, (DWORD)this, myMOTION_DETECTION_CALLBACK );
		M_KSetDICallback( m_hSDK, (DWORD)this, myDI_CALLBACK );
	}

	M_KSetNetworkLossCallback( m_hSDK, (DWORD)this, myNETWORK_LOSS_CALLBACK );
	M_KSetStreamingType( m_hSDK, m_MMS->nTCPType );
	M_KSetMediaConfig( m_hSDK, &m_MCC, &m_SEC );

	MEDIA_RENDER_INFO mri;

	mri.hWnd = m_hWnd;
	mri.rect.top = 0;
	mri.rect.left = 0;
	mri.rect.right = m_nScreenWidth;
	mri.rect.bottom = m_nScreenHeight;
	M_KSetRenderInfo( m_hSDK, &mri );

	if( m_MMS->bEnablePTZ )
	{
		MEDIA_PTZ_PROTOCOL mpp;
		mpp.dwAddressID = m_MMS->nPTZAddressID;
		mpp.nSourceType = m_MMS->nPTZProtocolSourceType;
		sprintf( mpp.szVender, "%s\0", m_MMS->szPTZVender );
		sprintf( mpp.szProtocol, "%s\0", m_MMS->szPTZProtocol );
		sprintf( mpp.szProtocolFilename, "%s\0", m_MMS->szPTZProtocolFileName );
		M_KEnablePTZProtocol( m_hSDK, true, &mpp );

		for( int i = 0; i < 8; i++ )
		{
			m_Menu.EnableMenuItem( ID_PTZSETPRESET_SETTOPRESET1 + i, MF_ENABLED );
			m_Menu.EnableMenuItem( ID_PTZPRESET_GOTO_PRESET1    + i, MF_ENABLED );
		}

		for( int i = 0; i < 5; i++ )
		{
			m_Menu.EnableMenuItem( ID_PTZSPEED_SPEED1 + i, MF_ENABLED );
			if( (i+1) == m_MMS->nPTZSpeed )
				m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1 + i, MF_CHECKED );
			else
				m_Menu.CheckMenuItem( ID_PTZSPEED_SPEED1 + i, MF_UNCHECKED );
		}
		m_Menu.EnableMenuItem( ID_PTZOSD_ON, MF_ENABLED );
		m_Menu.EnableMenuItem( ID_PTZOSD_OFF, MF_ENABLED );
	}

	else
	{
		for( int i = 0; i < 8; i++ )
		{
			m_Menu.EnableMenuItem( ID_PTZSETPRESET_SETTOPRESET1 + i, MF_GRAYED );
			m_Menu.EnableMenuItem( ID_PTZPRESET_GOTO_PRESET1    + i, MF_GRAYED );
		}
		for( int i = 0; i < 5; i++ )
			m_Menu.EnableMenuItem( ID_PTZSPEED_SPEED1 + i, MF_GRAYED );

		m_Menu.EnableMenuItem( ID_PTZOSD_ON, MF_GRAYED );
		m_Menu.EnableMenuItem( ID_PTZOSD_OFF, MF_GRAYED );
	}

	if( m_MMS->bQuad )
	{
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR1, MF_ENABLED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR2, MF_ENABLED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR3, MF_ENABLED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR4, MF_ENABLED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_MONITORQUAD, MF_ENABLED );
	}

	else
	{
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR1, MF_GRAYED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR2, MF_GRAYED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR3, MF_GRAYED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_DISPLAYMONITOR4, MF_GRAYED );
		m_Menu.EnableMenuItem( ID_QAUDSWITCH_MONITORQUAD, MF_GRAYED );
	}

	if( m_MMS->bPlayAudio )
	{
		if( m_hSDK ) M_KSetMute( m_hSDK, true );

		m_Menu.CheckMenuItem( ID_AUDIO_ON, MF_CHECKED );
		m_Menu.CheckMenuItem( ID_AUDIO_OFF, MF_UNCHECKED );
	}

	else
	{
		if( m_hSDK ) M_KSetMute( m_hSDK, false );
		m_Menu.CheckMenuItem( ID_AUDIO_ON, MF_UNCHECKED );
		m_Menu.CheckMenuItem( ID_AUDIO_OFF, MF_CHECKED );
	}

	m_bShowCameraName = m_MMS->bShowCameraName;

	m_bDO1Checked = false;
	m_bEnablePTZOSD = false;
	m_Menu.CheckMenuItem( ID_AUDIO_ON32817, MF_UNCHECKED );
	m_Menu.CheckMenuItem( ID_AUDIO_OFF32818, MF_CHECKED );
	//	m_Menu.CheckMenuItem( ID_PTZOSD_ON, MF_UNCHECKED );
	//	m_Menu.CheckMenuItem( ID_PTZOSD_OFF, MF_CHECKED );
	/*
	CString csID;
	csID.Format( L"%d - ", m_MMS->nIndexNO+1 );
	CString csName;
	csName = m_MMS->szCameraName;
	m_CameraName = csID + csName;
	*/
	sprintf( m_szCameraName, " %d - %s\0", m_MMS->nIndexNO+1, m_MMS->szCameraName );

	CFont font;
	font.CreateFont(
		12,                        // nHeight
		0,                         // nWidth
		0,                         // nEscapement
		0,                         // nOrientation
		FW_NORMAL,                 // nWeight
		FALSE,                     // bItalic
		FALSE,                     // bUnderline
		0,                         // cStrikeOut
		ANSI_CHARSET,              // nCharSet
		OUT_DEFAULT_PRECIS,        // nOutPrecision
		CLIP_DEFAULT_PRECIS,       // nClipPrecision
		DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
		L"Arial");

	RECT rect;
	rect.left = 0;
	rect.top = 0;
	rect.right = (strlen(m_szCameraName) + 1) * 12;
	rect.bottom = 16;

	m_stCameraName.SetTextColor( YELLOW );
	m_stCameraName.SetBkColor( BLUE );
	m_stCameraName.SetFont( &font );
	m_stCameraName.SetWindowPos( NULL, rect.left, rect.top, rect.right/2, rect.bottom, SWP_SHOWWINDOW|SWP_NOZORDER );
	m_stCameraName.SetWindowText( (CString)m_szCameraName );
	m_stCameraName.ShowWindow( SW_HIDE );

	m_myProgressCtrl.SetRange( 0, PROG_RANG );
	m_nCount = 0;
	m_bGoCount = true;
	if( !bPatrol )
		m_hConnectThread = CreateThread( NULL, 0, myConnecter, (LPVOID)this, 0, NULL );
	else
		m_hConnectThread = CreateThread( NULL, 0, myConnecterPatrol, (LPVOID)this, 0, NULL );

	m_hCounterThread = CreateThread( NULL, 0, myCounter, (LPVOID)this, 0, NULL );
	return true;
}

void CWideVideoDlg::DisConnectChannel()
{
	GetDlgItem( IDC_MOTION1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_MOTION2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_MOTION3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_MOTION4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_DI1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_DI2 )->ShowWindow( SW_HIDE );
	m_stCameraName.ShowWindow( SW_HIDE );

	HANDLE h = m_hSDK;
	m_hSDK = NULL;
	if( m_bDO1Checked ) M_KSendDO( h, 0x00 );
	m_bGoCount = false;
	m_bPlaying = false;
	WaitForSingleObject( m_hCounterThread, 10000 );
	WaitForSingleObject( m_hConnectThread, 10000 );
	CloseHandle( m_hCounterThread );
	CloseHandle( m_hConnectThread );
	m_hCounterThread = NULL;
	m_hConnectThread = NULL;
	WaitForSingleObject( m_hDrawInfo, INFINITE );
	M_KDisconnect( h );
	M_KCloseInterface( h );
}

void CWideVideoDlg::FillMobileVideoSetting( int nIndex, MOBILE_MEDIA_SETTING *pIn )
{
	m_pMSSAll[nIndex] = pIn;
}

void CWideVideoDlg::SetStartPatrolIndex( int nStart )
{
	m_nPatrolStart = nStart;
}

void CWideVideoDlg::Reaction_LBUTTONDOWN( int x, int y )
{
	int nX = x;
	int nY = y;

	if( !m_MMS->bEnablePTZ )
		return;
	int nSpeed = m_MMS->nPTZSpeed;
	if( nSpeed == 0 ) nSpeed = 3;

	m_pntLastMouseZone = CheckZone( nX, nY );
	switch( m_pntLastMouseZone )
	{
		/*	 _____ _____ _____
		|     |     |     |
		|  1  |  4  |  8  |
		|_____|_____|_____|
		|     |  5  |     |
		|  2  |-----|  9  |
		|_____|__6__|_____|
		|     |     |     |
		|  3  |  7  | 10  |
		|_____|_____|_____|		*/
	case 1 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 1;
				GetDlgItem( IDC_PTZ_UPLEFT )->SetWindowPos( NULL, nX-24, nY-24, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_UPLEFT )->ShowWindow( SW_SHOW );
				M_KPTZ_UP_LEFT( m_hSDK, nSpeed );
			}
		}
		break;
	case 2 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 2;
				GetDlgItem( IDC_PTZ_LEFT )->SetWindowPos( NULL, nX-24, nY-12, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_LEFT )->ShowWindow( SW_SHOW );
				M_KPTZ_LEFT( m_hSDK, nSpeed );
			}
		}
		break;
	case 3 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 3;
				GetDlgItem( IDC_PTZ_DOWNLEFT )->SetWindowPos( NULL, nX-24, nY, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_DOWNLEFT )->ShowWindow( SW_SHOW );
				M_KPTZ_DOWN_LEFT( m_hSDK, nSpeed );
			}
		}
		break;
	case 4 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 4;
				GetDlgItem( IDC_PTZ_UP )->SetWindowPos( NULL, nX-12, nY, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_UP )->ShowWindow( SW_SHOW );
				M_KPTZ_UP( m_hSDK, nSpeed );
			}
		}
		break;
	case 5 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 5;
				GetDlgItem( IDC_PTZ_ZOOMIN )->SetWindowPos( NULL, nX-24, nY-12, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_ZOOMIN )->ShowWindow( SW_SHOW );
				M_KPTZ_ZOOM_IN( m_hSDK );
			}
		}
		break;
	case 6 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 6;
				GetDlgItem( IDC_PTZ_ZOOMOUT )->SetWindowPos( NULL, nX-24, nY-12, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_ZOOMOUT )->ShowWindow( SW_SHOW );
				M_KPTZ_ZOOM_OUT( m_hSDK );
			}
		}
		break;
	case 7 : 
		{

			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 7;
				GetDlgItem( IDC_PTZ_DOWN )->SetWindowPos( NULL, nX-12, nY, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_DOWN )->ShowWindow( SW_SHOW );
				M_KPTZ_DOWN( m_hSDK, nSpeed );
			}
		}
		break;
	case 8 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 8;
				GetDlgItem( IDC_PTZ_UPRIGHT )->SetWindowPos( NULL, nX-24, nY, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_UPRIGHT )->ShowWindow( SW_SHOW );
				M_KPTZ_UP_RIGHT( m_hSDK, nSpeed );
			}
		}
		break;
	case 9 : 
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 9;
				GetDlgItem( IDC_PTZ_RIGHT )->SetWindowPos( NULL, nX-24, nY-12, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_RIGHT )->ShowWindow( SW_SHOW );
				M_KPTZ_RIGHT( m_hSDK, nSpeed );
			}
		}
		break; 
	case 10 :
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				m_nLastPTZCommand = 10;
				GetDlgItem( IDC_PTZ_DOWNRIGHT )->SetWindowPos( NULL, nX-24, nY-24, 24, 24, SWP_SHOWWINDOW|SWP_NOZORDER );
				GetDlgItem( IDC_PTZ_DOWNRIGHT )->ShowWindow( SW_SHOW );
				M_KPTZ_DOWN_RIGHT( m_hSDK, nSpeed );
			}
		}
		break;
	}
}

void CWideVideoDlg::Reaction_LBUTTONUP( int x, int y )
{
	if( m_MMS->bEnablePTZ )
	{

		if( m_hSDK ) 
		{
			switch( m_nLastPTZCommand )
			{
			case 1:
				GetDlgItem( IDC_PTZ_UPLEFT )->ShowWindow( SW_HIDE );
				M_KPTZ_STOP( m_hSDK, 0 );
				break;
			case 3:
				GetDlgItem( IDC_PTZ_DOWNLEFT )->ShowWindow( SW_HIDE );
				M_KPTZ_STOP( m_hSDK, 0 );
				break;
			case 8:
				GetDlgItem( IDC_PTZ_UPRIGHT )->ShowWindow( SW_HIDE );
				M_KPTZ_STOP( m_hSDK, 0 );
				break;
			case 10:
				GetDlgItem( IDC_PTZ_DOWNRIGHT )->ShowWindow( SW_HIDE );
				M_KPTZ_STOP( m_hSDK, 0 );		
				break;
			case 2: 
				M_KPTZ_STOP( m_hSDK, 3 );
				GetDlgItem( IDC_PTZ_LEFT )->ShowWindow( SW_HIDE );
				break;
			case 4: 
				M_KPTZ_STOP( m_hSDK, 1 );			
				GetDlgItem( IDC_PTZ_UP )->ShowWindow( SW_HIDE );
				break;
			case 7: 
				M_KPTZ_STOP( m_hSDK, 2 );
				GetDlgItem( IDC_PTZ_DOWN )->ShowWindow( SW_HIDE );
				break;
			case 9: 
				M_KPTZ_STOP( m_hSDK, 4 );			
				GetDlgItem( IDC_PTZ_RIGHT )->ShowWindow( SW_HIDE );
				break;
			case 5:
				GetDlgItem( IDC_PTZ_ZOOMIN )->ShowWindow( SW_HIDE );
				M_KPTZ_ZOOM_IN_STOP( m_hSDK );
				break;
			case 6:
				GetDlgItem( IDC_PTZ_ZOOMOUT )->ShowWindow( SW_HIDE );
				M_KPTZ_ZOOM_OUT_STOP( m_hSDK );
				break;
			default:
				break;
			}
		}
	}
}

int CWideVideoDlg::CheckZone( int x, int y )
{
	int nX = x;
	int nY = y;
	int nBlock_W = m_nScreenWidth / 3;
	int nBlock_H = m_nScreenHeight / 3;

	/*	 _____ _____ _____
	|     |     |     |
	|  1  |  4  |  8  |
	|_____|_____|_____|
	|     |  5  |     |
	|  2  |-----|  9  |
	|_____|__6__|_____|
	|     |     |     |
	|  3  |  7  | 10  |
	|_____|_____|_____|		*/

	if( nX < nBlock_W )
	{
		if( nY < nBlock_H )						return 1;
		else if( nY < (nBlock_H * 2) )			return 2;
		else									return 3;
	}

	else if( nX < (nBlock_W * 2) )
	{
		if( nY < nBlock_H )						return 4;
		else if( nY < (nBlock_H * 2) )
		{
			if( nY < (m_nScreenHeight / 2) )	return 5;
			else								return 6;
		}
		else									return 7;
	}
	else
	{
		if( nY < nBlock_H )						return 8;
		else if( nY < (nBlock_H * 2) )			return 9;
		else									return 10;
	}
	return 0;
}

void CWideVideoDlg::Reaction_MOUSEMOVE( int x, int y )
{
	int nX = x;
	int nY = y;
	int nZone = CheckZone( nX, nY );

	if( nZone != m_pntLastMouseZone )
	{
		Reaction_LBUTTONUP( nX, nY );
		Reaction_LBUTTONDOWN( nX, nY );
	}
}

void CWideVideoDlg::AfterRender()
{
	/*
	if( m_bPlaying && m_bShowCameraName )
	{
	int nFontsize = 14;
	ResetEvent( m_hDrawInfo );
	CRect rect( 10, 10, m_CameraName.GetLength()*nFontsize, 10 + nFontsize );
	CDC *pDC = GetDC();
	pDC->SetTextColor( RGB( 0, 0, 255 ) );
	pDC->SetBkColor( RGB(128,128,128) );
	pDC->DrawText( m_CameraName.GetBuffer(), m_CameraName.GetLength(), &rect, DT_LEFT );//CRect( 10, 10, 60, 20 ) );
	m_CameraName.ReleaseBuffer();
	ReleaseDC( pDC );
	SetEvent( m_hDrawInfo );
	}
	*/
}
void CWideVideoDlg::Reaction_KEYDOWN( int nKey )
{
	//TCHAR log[32];
	//wsprintf( log, L"%d", nKey );
	//MessageBox( log, log );
	switch( nKey )
	{
	case 51:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			m_nLastPTZCommand = 5;
			M_KPTZ_ZOOM_IN( m_hSDK );
		}
		break;
	case 79:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			m_nLastPTZCommand = 6;
			M_KPTZ_ZOOM_OUT( m_hSDK );
		}
		break;
	case 87: //W
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			m_nLastPTZCommand = 4;
			M_KPTZ_UP( m_hSDK, m_MMS->nPTZSpeed == 0 ? 3 : m_MMS->nPTZSpeed );
		}
		break;
	case 65: //A
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			m_nLastPTZCommand = 2;
			M_KPTZ_LEFT( m_hSDK, m_MMS->nPTZSpeed == 0 ? 3 : m_MMS->nPTZSpeed );
		}
		break;
	case 52: // D
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			m_nLastPTZCommand = 9;
			M_KPTZ_RIGHT( m_hSDK, m_MMS->nPTZSpeed == 0 ? 3 : m_MMS->nPTZSpeed );
		}
		break;
	case 83: //S
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			m_nLastPTZCommand = 7;
			M_KPTZ_DOWN( m_hSDK, m_MMS->nPTZSpeed == 0 ? 3 : m_MMS->nPTZSpeed );
		}
		break;
	case 38: // UP
		{
			if( m_bEnablePTZOSD )
			{
				if( m_MMS->bEnablePTZ && m_hSDK )
					M_KPTZ_OSD_UP( m_hSDK );
			}
			else
			{
				int nTmp = m_nPatrolStart;
				while( !m_bGoCount )
				{
					if( m_nPatrolStart > 0 )
						m_nPatrolStart--;

					else
						m_nPatrolStart = 15;

					if( m_nPatrolStart == nTmp )
					{
						::MessageBox( m_hWnd, L"No camara to do patorl!", L"Patrol", MB_OK );
						break;
					}

					if( m_pMSSAll[m_nPatrolStart]->bGroupIntoPatrol )
					{
						DisConnectChannel();
						Invalidate();
						ConnectChannel( m_nPatrolStart, true );
						break;
					}
				}
			}
		}
		break;
	case 40: // DOWN
		{
			if( m_bEnablePTZOSD )
			{
				if( m_MMS->bEnablePTZ && m_hSDK )
					M_KPTZ_OSD_DOWN( m_hSDK );
			}
			else
			{
				int nTmp = m_nPatrolStart;
				while( !m_bGoCount )
				{
					if( m_nPatrolStart < 15 )
						m_nPatrolStart++;

					else
						m_nPatrolStart = 0;

					if( m_nPatrolStart == nTmp )
					{
						::MessageBox( m_hWnd, L"No camara to do patorl!", L"Patrol", MB_OK );
						break;
					}

					if( m_pMSSAll[m_nPatrolStart]->bGroupIntoPatrol )
					{
						DisConnectChannel();
						Invalidate();
						ConnectChannel( m_nPatrolStart, true );
						break;
					}
				}
			}
		}
		break;
	case 37: // LEFT
		{
			if( m_bEnablePTZOSD )
			{
				if( m_MMS->bEnablePTZ && m_hSDK )
					M_KPTZ_OSD_LEAVE( m_hSDK );
			}
		}
		break;
	case 39: // RIGHT
		{
			if( m_bEnablePTZOSD )
			{
				if( m_MMS->bEnablePTZ && m_hSDK )
					M_KPTZ_OSD_ENTER( m_hSDK );
			}
		}
		break;
	default:
		break;
	}
}

void CWideVideoDlg::Reaction_KEYUP( int nKey )
{
	switch( nKey )
	{
	case 51:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			M_KPTZ_ZOOM_IN_STOP( m_hSDK );
		}
		break;
	case 79:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			M_KPTZ_ZOOM_OUT_STOP( m_hSDK );
		}
		break;
	case 87:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			M_KPTZ_STOP( m_hSDK, 1 );
		}
		break;
	case 65:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			M_KPTZ_STOP( m_hSDK, 3 );
		}
		break;
	case 52:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			M_KPTZ_STOP( m_hSDK, 4 );
		}
		break;
	case 83:
		if( m_MMS->bEnablePTZ )
		{
			if( m_hSDK == NULL ) return;
			M_KPTZ_STOP( m_hSDK, 2 );
		}
		break;
	case 38: // UP
		{
			if( m_MMS->bEnablePTZ )
			{
				if( m_hSDK == NULL ) return;
				M_KPTZ_STOP( m_hSDK, 1 );
			}
			/*
			if( m_bEnablePTZOSD )
			{
				if( m_MMS->bEnablePTZ && m_hSDK )
					M_KPTZ_STOP( m_hSDK, 1 );
			}
			*/
		}
		break;
	case 40: // DOWN
		{
			if( m_bEnablePTZOSD )
			{
				if( m_MMS->bEnablePTZ && m_hSDK )
					M_KPTZ_STOP( m_hSDK, 2 );
			}
		}
		break;
	case 37: // LEFT
		{
		}
		break;
	case 39: // RIGHT
		{
		}
		break;
	default:
		break;
	}
}

void CWideVideoDlg::OnRecognizeGesture(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = TRUE; 
} 

void CWideVideoDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	Default(); 
}

wchar_t* CWideVideoDlg::ASCIItoUNICODE( const char* source)
{
	int length = strlen( source );
	wchar_t* dest = new wchar_t[length+1];
	MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, source, length, dest, length );
	dest[length] = 0;
	return dest;
}

void CWideVideoDlg::NetWorkLoss()
{
	if( ::MessageBox( m_hWnd, L"Network Loss!\nReturn to main menu?", L"Connection", MB_YESNO ) == IDYES )
		PostMessage( WM_CLOSE, 0, 0 );
}

void CWideVideoDlg::MotionDetection( bool bM1, bool bM2, bool bM3, bool bM4 )
{
	m_bMotion[0] = bM1;
	m_bMotion[1] = bM2;
	m_bMotion[2] = bM3;
	m_bMotion[3] = bM4;
}

void CWideVideoDlg::DigitalIn( bool bDI1, bool bDI2 )
{
	m_bDI[0] = bDI1;
	m_bDI[1] = bDI2;
}