#pragma once

#include "BDialog.h"
#include "colorstatic.h"
#include "afxwin.h"
//#include "afxcmn.h"


// CWideVideoDlg dialog

class CWideVideoDlg : public CBDialog
{
	DECLARE_DYNAMIC(CWideVideoDlg)

public:
	CWideVideoDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CWideVideoDlg();

	afx_msg void OnRecognizeGesture(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
// Dialog Data
	enum { IDD = IDD_VIDEO_DIALOG1 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
private:
	int							m_nCount;
	HANDLE						m_hCounterThread;
	HANDLE						m_hConnectThread;
	CProgressCtrl				m_myProgressCtrl;
	bool						m_bGoCount;
	int							m_nScreenWidth;
	int							m_nScreenHeight;
	bool						m_bPlaying;
	CMenu						m_Menu;
	int							m_nPatrolStart;
	HANDLE						m_hSDK;
	MOBILE_MEDIA_SETTING *		m_MMS;
	MOBILE_MEDIA_SETTING *		m_pMSSAll[16];
	MEDIA_CONNECTION_CONFIG		m_MCC;
	STREAMING_ENGINE_CONFIG		m_SEC;
	bool						m_bEnableSE;
	bool						m_bEnableMouseMove;
	int							m_pntLastMouseZone;
	bool						m_bShowCameraName;
	CString						m_CameraName;
	char						m_szCameraName[128];
	HANDLE						m_hDrawInfo;
	int							m_nLastPTZCommand;
	bool						m_bEnablePTZOSD;
	int							m_bDO1Checked;
	bool						m_bMotion[4];
	bool						m_bDI[2];

	void	Reaction_LBUTTONDOWN( int x, int y );
	void	Reaction_LBUTTONUP( int x, int y );
	void	Reaction_MOUSEMOVE( int x, int y );
	void	Reaction_KEYDOWN( int nKey );
	void	Reaction_KEYUP( int nKey );
	int		CheckZone( int x, int y );
	bool	ConnectChannel( int nChannel, bool bPatrol );
	void	DisConnectChannel();

private:
	afx_msg void OnPaint();
	afx_msg void OnClose();
	afx_msg void OnOK();
	LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
public:
	void	Counter();
	void	Connecter();
	void	ConnecterPatrol();
	void	AfterRender();
	void	NetWorkLoss();
	void	SetMobileVideoSetting( MOBILE_MEDIA_SETTING *pIn );
	void	FillMobileVideoSetting( int nIndex, MOBILE_MEDIA_SETTING *pIn );
	void	SetStartPatrolIndex( int nStart );
	wchar_t* ASCIItoUNICODE( const char* source);

	void MotionDetection( bool bM1, bool bM2, bool bM3, bool bM4 );
	void DigitalIn( bool bDI1, bool bDI2 );
	bool ExchangeHostNameToIP( char* szpHostName, char* szIPBuffer );
public:
	CColorStatic m_stCameraName;
};
